(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: listutil.mli,v 1.3 2007/04/26 10:58:05 blanqui Exp $ *)

(* Eliminates duplicates in a list. *)

val unique : 'a list -> 'a list;;

(* Eliminates duplicates in a list sorted in increasing order.
Result list in decreasing order. *)

val unique_sorted : 'a list -> 'a list;;

(* Membership in a list sorted in increasing order. *)

val mem_sorted : ('a -> 'a -> int) -> 'a -> 'a list -> bool;;

(* Provides the x's of Some(x)'s obtained by f. *)

val filter_map_opt : ('a -> 'b option) -> 'a list -> 'b list;;
